/******************************************************************************
 *
 * Copyright (c) 1999 Palm Computing, Inc. or its subsidiaries.
 * All rights reserved.
 *
 * File: Starter.cpp
 *
 *****************************************************************************/

#include <PalmOS.h>
#include "StarterRsc.h"


/***********************************************************************
 *
 *	Entry Points
 *
 ***********************************************************************/


/***********************************************************************
 *
 *	Internal Structures
 *
 ***********************************************************************/

/***********************************************************************
 *
 *	Global variables
 *
 ***********************************************************************/
//static Boolean HideSecretRecords;
MemPtr RcrdMp[683];
UInt16 RcrdIndex[683];
UInt8 RcrdSz[683];
UInt8 YomiSz[683];
UInt8 KakiSz[683];

LocalID ATOKLrnEditTmpDBId;
DmOpenRef ATOKLrnEditTmpDBRef;
MemHandle ATD2LrnTmpLrnRecMh;
MemPtr ATD2LrnTmpLrnRecMp;
Boolean ATOKLrnEditTmpDBOpened;
Boolean Alerted;
Boolean ATOKActive;
/***********************************************************************
 *
 *	Internal Constants
 *
 ***********************************************************************/
#define appFileCreator			'LrnE'	// register your own at http://www.palmos.com/dev/creatorid/
#define appVersionNum			0x01
#define appPrefID				0x00
#define appPrefVersionNum		0x01

// Define the minimum OS version we support (2.0 for now).
#define kOurMinVersion	sysMakeROMVersion(2,0,0,sysROMStageRelease,0)
#define kPalmOS10Version	sysMakeROMVersion(1,0,0,sysROMStageRelease,0)

#define MsgError		0x00
#define MsgConfirm		0x01
#define MsgInformation	0x02
#define SysUIAppSwitchTrapFtrNum	0x01
#define SysUIAppSwitchTrapLnchrCrtrId	0x02

/***********************************************************************
 *
 *	Internal Functions
 *
 ***********************************************************************/
/* TODO:֐̐錾KvłΒǉ */
Err MakeATOKLrnEditTmpDB();
Err DrawList();
Err FillRecList(Int8 ScrollDirection);
void ResetDeleteFlug();
void GetDeleteFlug();
void UpdateATD2LrnRec();
Boolean CheckVersion();
void BackUp();
Boolean Restore();
void DeleteBackup();
UInt32 GetAddr(UInt32 ATD2LrnRecIndex1Addr, UInt16 RecLstAddr, UInt16 Offset);
UInt16 FrmAlert (UInt16 type, UInt16 msgID);
void LaunchATOK();
void FrmRefresh();
Boolean ChkATOKActive();
Boolean ChkATOK();
void sortRes();
DmResID sort(DmResID FstResID, DmResID LstResID);
typedef Err (*SysUIAppSwitchTrapType)
	(UInt16 cardNo, LocalID dbID, UInt16 cmd, MemPtr cmdPBP);

static Err SysUIAppSwitchTrapHack(UInt16 cardNo, LocalID dbID, UInt16 cmd, MemPtr cmdPBP)
{
	UInt32 oldtrapadd;
	UInt32 LnchrCrtrId;
	SysUIAppSwitchTrapType oldTrap;

	FtrGet ('LrnE', SysUIAppSwitchTrapFtrNum, &oldtrapadd);
	FtrGet ('LrnE', SysUIAppSwitchTrapLnchrCrtrId, &LnchrCrtrId);

	DmOpenRef LnchrdbP = DmOpenDatabaseByTypeCreator ('appl', LnchrCrtrId, dmModeReadOnly);
	LocalID LnchrdbID;
	DmOpenDatabaseInfo (LnchrdbP, &LnchrdbID, NULL, NULL, NULL, NULL);
	DmCloseDatabase (LnchrdbP);

	if (dbID == LnchrdbID)
	{
		dbID = DmFindDatabase (0, "ATOKLrnEdit");
		SysSetTrapAddress (sysTrapSysUIAppSwitch, (UInt32*)oldtrapadd);
		FtrUnregister ('LrnE', SysUIAppSwitchTrapFtrNum);
		FtrUnregister ('LrnE', SysUIAppSwitchTrapLnchrCrtrId);
	}

	oldTrap = (SysUIAppSwitchTrapType)oldtrapadd;
	return oldTrap(cardNo, dbID, cmd, cmdPBP);
}

/***********************************************************************
 *
 * FUNCTION:    RomVersionCompatible
 *
 * DESCRIPTION: This routine checks that a ROM version is meet your
 *              minimum requirement.
 *
 * PARAMETERS:  requiredVersion - minimum rom version required
 *                                (see sysFtrNumROMVersion in SystemMgr.h 
 *                                for format)
 *              launchFlags     - flags that indicate if the application 
 *                                UI is initialized.
 *
 * RETURNED:    error code or zero if rom is compatible
 *
 * REVISION HISTORY:
 *
 *
 ***********************************************************************/
static Err RomVersionCompatible(UInt32 requiredVersion, UInt16 launchFlags)
{
	UInt32 romVersion;

	// See if we're on in minimum required version of the ROM or later.
	FtrGet(sysFtrCreator, sysFtrNumROMVersion, &romVersion);
	if (romVersion < requiredVersion)
		{
		if ((launchFlags & (sysAppLaunchFlagNewGlobals | sysAppLaunchFlagUIApp)) ==
			(sysAppLaunchFlagNewGlobals | sysAppLaunchFlagUIApp))
			{
			FrmAlert (RomIncompatibleAlert);
		
			// Palm OS 1.0 will continuously relaunch this app unless we switch to 
			// another safe one.
			if (romVersion <= kPalmOS10Version)
				{
				AppLaunchWithCommand(sysFileCDefaultApp, sysAppLaunchCmdNormalLaunch, NULL);
				}
			}
		
		return sysErrRomIncompatible;
		}

	return errNone;
}


/***********************************************************************
 *
 * FUNCTION:    GetObjectPtr
 *
 * DESCRIPTION: This routine returns a pointer to an object in the current
 *              form.
 *
 * PARAMETERS:  formId - id of the form to display
 *
 * RETURNED:    void *
 *
 * REVISION HISTORY:
 *
 *
 ***********************************************************************/
static void * GetObjectPtr(UInt16 objectID)
{
	FormPtr frmP;

	frmP = FrmGetActiveForm();
	return FrmGetObjectPtr(frmP, FrmGetObjectIndex(frmP, objectID));
}


/***********************************************************************
 *
 * FUNCTION:    MainFormInit
 *
 * DESCRIPTION: This routine initializes the MainForm form.
 *
 * PARAMETERS:  frm - pointer to the MainForm form.
 *
 * RETURNED:    nothing
 *
 * REVISION HISTORY:
 *
 *
 ***********************************************************************/
static void MainFormInit(FormPtr /*frmP*/)
{
	Alerted = false;
	ATOKActive = ChkATOK();
	ATOKLrnEditTmpDBOpened = false;

	DrawList();

	FrmInitForm (WaitForm);

	if (MakeATOKLrnEditTmpDB() == false)
		return;
	FillRecList(0);

	return;
}


/***********************************************************************
 *
 * FUNCTION:    MainFormDoCommand
 *
 * DESCRIPTION: This routine performs the menu command specified.
 *
 * PARAMETERS:  command  - menu item id
 *
 * RETURNED:    nothing
 *
 * REVISION HISTORY:
 *
 *
 ***********************************************************************/
static Boolean MainFormDoCommand(UInt16 command)
{
	Boolean handled = false;
//	FormPtr frmP;

	switch (command)
		{
/*		case MainOptionsAboutStarterApp:
			MenuEraseStatus(0);					// Clear the menu status from the display.
			frmP = FrmInitForm (AboutForm);
			FrmDoDialog (frmP);					// Display the About Box.
			FrmDeleteForm (frmP);
			handled = true;
			break;
*/
		case MenuTitle1000Backup:// Menu Text: obNAbv̍쐬...
			{
				if (FrmAlert (CnfBackupAlert) == CnfBackupYes)// "obNAbv쐬܂
					{
						BackUp();
					}
			}
			handled = true;
			break;

		case MenuTitle1000Restore:// Menu Text: obNAbv̕...
			{
				if (ChkATOKActive() == false)
				{
					if (FrmAlert (RestoreConfAlert) == RestoreConfYes)// "obNAbv畜܂"
					{
						if (Restore() == true)
							if (FrmAlert (RestoreDoneAlert) == RestoreDoneATOK)
							{
								LaunchATOK();
								handled = true;
								break;
							}
						MakeATOKLrnEditTmpDB();
						FillRecList(0);
						FrmRefresh();
					}
				}
			}
			handled = true;
			break;
			
		case MenuTitle1000DeleteBackup:// Menu Text: obNAbv̍폜...
			{
				if (FrmAlert (DelBackupConfAlert) == DelBackupConfYes)// "obNAbv폜܂"
					{
						DeleteBackup();
					}
			}
			handled = true;
			break;
			
			
		case MenuTitle1000LaunchATOK:// Menu Text: Launch ATOK
			{
				if (FrmAlert (CnfLaunchATOKAlert) == CnfLaunchATOKOK)// "obNAbv폜܂"
					{
						LaunchATOK ();
					}
			}
			handled = true;
			break;
			
		case MenuTitle1000About:// Menu Text: m藚ҏWɂ
			{
				FrmAlert (AboutAlert);// "m藚ҏW 2  http://www5f.biglobe.ne.jp/~T-Pilot"
			}
			handled = true;
			break;
			
		default:
			break;

		}
	
	return handled;
}


/***********************************************************************
 *
 * FUNCTION:    MainFormHandleEvent
 *
 * DESCRIPTION: This routine is the event handler for the 
 *              "MainForm" of this application.
 *
 * PARAMETERS:  eventP  - a pointer to an EventType structure
 *
 * RETURNED:    true if the event has handle and should not be passed
 *              to a higher level handler.
 *
 * REVISION HISTORY:
 *
 *
 ***********************************************************************/
static Boolean MainFormHandleEvent(EventPtr eventP)
{
	Boolean handled = false;
	FormPtr frmP;
//	RectangleType rP;

	switch (eventP->eType) 
		{
		case menuEvent:
			return MainFormDoCommand(eventP->data.menu.itemID);

		case frmOpenEvent:
			frmP = FrmGetActiveForm();
			MainFormInit( frmP);
//			FrmDrawForm ( frmP);
			FrmRefresh();
//			ChkATOKActive();
//			FrmUpdateForm (MainForm, frmRedrawUpdateCode);//--------------------------------
//			RctSetRectangle (&rP, 8, 27, 144, 101);
//			WinDrawRectangleFrame (simpleFrame, &rP);
//			RctSetRectangle (&rP, 8, 27, 144, 101);
//			WinDrawRectangleFrame (simpleFrame, &rP);
//			FrmSetActiveForm(frmP);
			handled = true;
			break;
			
		case frmUpdateEvent:
			// To do any custom drawing here, first call FrmDrawForm(), then do your
			// drawing, and then set handled to true.
			break;

		case sclRepeatEvent:
			FillRecList(0);
			return false;
			break;

		case ctlSelectEvent:
			switch (eventP->data.ctlSelect.controlID)
				{
				case MainRunButton:
//					testFtr();//----------------------------------------------------
					if (ChkATOKActive() == false)
					{
						if (FrmAlert (DelConfAlert) == DelConfYes)
						{
							GetDeleteFlug();
							UpdateATD2LrnRec();
							if (FrmAlert (DoneAlert) == DoneATOK)//
							{
								LaunchATOK();
								handled = true;
								break;
							}
							MakeATOKLrnEditTmpDB();
							FillRecList(0);
							FrmRefresh();
						}
					}

					handled = true;
					break;

				case MainCancelButton:
					ResetDeleteFlug();
					FillRecList(0);
					handled = true;
					break;

				case MainLaunchATOKButton:
					{
						if (FrmAlert (CnfLaunchATOKAlert) == CnfLaunchATOKOK)// "obNAbv폜܂"
							{
								LaunchATOK ();
							}
					}
					handled = true;
					break;

				case 1051:
				case 1052:
				case 1053:
				case 1054:
				case 1055:
				case 1056:
				case 1057:
				case 1058:
				case 1059:
					if (Alerted == false)
					{
						ChkATOKActive();
						Alerted = true;
					}
					GetDeleteFlug();
					handled = true;
					break;

				default:
					handled = false;
					break;
				}
			break;

		case keyDownEvent:
			switch (eventP->data.keyDown.chr)
				{
				case pageUpChr:
					FillRecList(-8);
					handled = true;
					break;

				case pageDownChr:
					FillRecList(+8);
					handled = true;
					break;

				default:
					handled = true;
					break;

				}
			break;

		default:
			break;
		
		}

	return handled;
}


/***********************************************************************
 *
 * FUNCTION:    AppHandleEvent
 *
 * DESCRIPTION: This routine loads form resources and set the event
 *              handler for the form loaded.
 *
 * PARAMETERS:  event  - a pointer to an EventType structure
 *
 * RETURNED:    true if the event has handle and should not be passed
 *              to a higher level handler.
 *
 * REVISION HISTORY:
 *
 *
 ***********************************************************************/
static Boolean AppHandleEvent(EventPtr eventP)
{
	UInt16 formId;
	FormPtr frmP;

	if (eventP->eType == frmLoadEvent)
		{
		// Load the form resource.
		formId = eventP->data.frmLoad.formID;
		frmP = FrmInitForm(formId);
		FrmSetActiveForm(frmP);

		// Set the event handler for the form.  The handler of the currently
		// active form is called by FrmHandleEvent each time is receives an
		// event.
		switch (formId)
			{
			case MainForm:
				FrmSetEventHandler(frmP, MainFormHandleEvent);
				break;

			default:
//				ErrFatalDisplay("Invalid Form Load Event");
				break;

			}
		return true;
		}
	
	return false;
}


/***********************************************************************
 *
 * FUNCTION:    AppEventLoop
 *
 * DESCRIPTION: This routine is the event loop for the application.  
 *
 * PARAMETERS:  nothing
 *
 * RETURNED:    nothing
 *
 * REVISION HISTORY:
 *
 *
 ***********************************************************************/
static void AppEventLoop(void)
{
	UInt16 error;
	EventType event;

	do {
		EvtGetEvent(&event, evtWaitForever);

		if (! SysHandleEvent(&event))
			if (! MenuHandleEvent(0, &event, &error))
				if (! AppHandleEvent(&event))
					FrmDispatchEvent(&event);

	} while (event.eType != appStopEvent);
}


/***********************************************************************
 *
 * FUNCTION:     AppStart
 *
 * DESCRIPTION:  Get the current application's preferences.
 *
 * PARAMETERS:   nothing
 *
 * RETURNED:     Err value 0 if nothing went wrong
 *
 * REVISION HISTORY:
 *
 *
 ***********************************************************************/
static Err AppStart(void)
{

	return errNone;
}


/***********************************************************************
 *
 * FUNCTION:    AppStop
 *
 * DESCRIPTION: Save the current state of the application.
 *
 * PARAMETERS:  nothing
 *
 * RETURNED:    nothing
 *
 * REVISION HISTORY:
 *
 *
 ***********************************************************************/
static void AppStop(void)
{
	LocalID dbID;

	if (ATOKLrnEditTmpDBOpened == true)
		DmCloseDatabase (ATOKLrnEditTmpDBRef);

	dbID = DmFindDatabase (0,"ATOKLrnEditTmpDB");
	if (dbID != 0)
		DmDeleteDatabase (0, dbID);

	// Close all the open forms.
	FrmCloseAllForms ();
}


/***********************************************************************
 *
 * FUNCTION:    StarterPalmMain
 *
 * DESCRIPTION: This is the main entry point for the application.
 *
 * PARAMETERS:  cmd - word value specifying the launch code. 
 *              cmdPB - pointer to a structure that is associated with the launch code. 
 *              launchFlags -  word value providing extra information about the launch.
 *
 * RETURNED:    Result of launch
 *
 * REVISION HISTORY:
 *
 *
 ***********************************************************************/
static UInt32 StarterPalmMain(UInt16 cmd, MemPtr cmdPBP, UInt16 launchFlags)
{
	Err error;

	error = RomVersionCompatible (kOurMinVersion, launchFlags);
	if (error) return (error);

	switch (cmd)
		{
		case sysAppLaunchCmdNormalLaunch:
			if (CheckVersion() == false)//
				return errNone;

			error = AppStart();
			if (error) 
				return error;
				
			FrmGotoForm(MainForm);
			AppEventLoop();
			AppStop();
			break;

		default:
			break;

		}
	
	return errNone;
}


/***********************************************************************
 *
 * FUNCTION:    PilotMain
 *
 * DESCRIPTION: This is the main entry point for the application.
 *
 * PARAMETERS:  cmd - word value specifying the launch code. 
 *              cmdPB - pointer to a structure that is associated with the launch code. 
 *              launchFlags -  word value providing extra information about the launch.
 * RETURNED:    Result of launch
 *
 * REVISION HISTORY:
 *
 *
 ***********************************************************************/
UInt32 PilotMain( UInt16 cmd, MemPtr cmdPBP, UInt16 launchFlags)
{
	return StarterPalmMain(cmd, cmdPBP, launchFlags);
}

/***********************************************************************
 * ֐
 **********************************************************************/
/* TODO:֐̐錾KvłΒǉ */
Err MakeATOKLrnEditTmpDB()
{

	Boolean ATD2LrnDbOpened = false;
	Boolean ATD2LrnDbRecMhLocked = false;
	Err error = false;
	Int16 j;

	DmOpenRef ATD2LrnDbRef;
	MemHandle ATD2LrnDbRecMh;
	MemPtr ATD2LrnDbRecMp;

	UInt8 ATD2LrnRecSize;

	UInt16 ATD2LrnValidRecNum = 0;
	UInt16 ATD2LrnInvalidRecNum = 0;

	UInt16 ATD2LrnValidRecTotalSize = 0;
	UInt16 ATD2LrnInvalidRecTotalSize = 0;

	UInt16 objIndex;
	
	
UInt32 LrnRecLstRecAddress;
UInt32 LrnRec1stRecAddress;
UInt16 offset = 0;

Boolean Flug;

//------------------------------------------------------------------------------
	FormType* pForm = FrmGetFormPtr (MainForm);
	FormPtr WaitfrmP = FrmGetFormPtr (WaitForm);
	FrmDrawForm (WaitfrmP);
//------------------------------------------------------------------------------

// Find Database "ATD2Lrn"
	ATD2LrnDbRef = DmOpenDatabase (0,DmFindDatabase (0, "ATD2Lrn"),dmModeReadOnly);
	if (ATD2LrnDbRef == 0)
	{
		error = true;
		goto Ret;
	}
	ATD2LrnDbOpened = true;
	ATD2LrnDbRecMh = DmQueryRecord (ATD2LrnDbRef,1);
	ATD2LrnDbRecMp = MemHandleLock (ATD2LrnDbRecMh);
	ATD2LrnDbRecMhLocked = true;
// Find Database "ATD2Lrn" end

// Create TempDb "ATOKLrnEditTmpDB"
	if (ATOKLrnEditTmpDBOpened == true)
	{
		DmCloseDatabase (ATOKLrnEditTmpDBRef);
		ATOKLrnEditTmpDBOpened = false;
	}

	ATOKLrnEditTmpDBId = DmFindDatabase (0,"ATOKLrnEditTmpDB");
	if (ATOKLrnEditTmpDBId != 0)
		DmDeleteDatabase (0, ATOKLrnEditTmpDBId);
	if (DmCreateDatabase (0,"ATOKLrnEditTmpDB",'LrnE','TpDb',true) != errNone)
	{
		error = true;
		goto Ret;
	}
	ATOKLrnEditTmpDBId = DmFindDatabase (0,"ATOKLrnEditTmpDB");
	ATOKLrnEditTmpDBRef = DmOpenDatabase (0,ATOKLrnEditTmpDBId,dmModeReadWrite);
	ATOKLrnEditTmpDBOpened = true;
// Create TempDb "ATOKLrnEditTmpDB"

	LrnRecLstRecAddress = *((UInt16*)ATD2LrnDbRecMp + 1);
	LrnRec1stRecAddress = *((UInt16*)ATD2LrnDbRecMp);
	
	if ( (LrnRec1stRecAddress == 0) && (LrnRecLstRecAddress == 0) )
	{
		error = false;
		goto Ret;
	}

	offset = 0;

	do
	{
		ATD2LrnRecSize = 
			*(UInt8*)GetAddr((UInt32)ATD2LrnDbRecMp, (UInt16)LrnRecLstRecAddress, offset)
			+ *(UInt8*)GetAddr((UInt32)ATD2LrnDbRecMp, (UInt16)LrnRecLstRecAddress, offset+ 1)
			+ 4;

		if (*(UInt8*)GetAddr((UInt32)ATD2LrnDbRecMp
			, (UInt16)LrnRecLstRecAddress
			, offset + ATD2LrnRecSize - 3) == 0x00)
		{
			offset += ATD2LrnRecSize;

			ATD2LrnInvalidRecNum++;
			ATD2LrnInvalidRecTotalSize += ((UInt16)ATD2LrnRecSize - 1);
		}
		else
		{
			ATD2LrnTmpLrnRecMh = 
//				DmNewRecord (ATOKLrnEditTmpDBRef,&ATD2LrnValidRecNum,(UInt32)ATD2LrnRecSize);
				DmNewResource (ATOKLrnEditTmpDBRef, 'temp', (DmResID)ATD2LrnValidRecNum, (UInt32)ATD2LrnRecSize + 1);
			if (ATD2LrnTmpLrnRecMh == 0)
			{
				error = true;
				goto Ret;
			}

			ATD2LrnTmpLrnRecMp = (UInt8*)MemHandleLock (ATD2LrnTmpLrnRecMh);
			for (j = (Int16)ATD2LrnRecSize + 1;j > 0 + 1;j--)
			{
				DmWrite (ATD2LrnTmpLrnRecMp
					, j - 1
					, (MemPtr)GetAddr((UInt32)ATD2LrnDbRecMp, (UInt16)LrnRecLstRecAddress, offset++)
					, (UInt32)1);
			}
			Flug = false;
			DmWrite (ATD2LrnTmpLrnRecMp
				, 0
				, &Flug
				, (UInt32)1);

			RcrdMp[ATD2LrnValidRecNum] = ATD2LrnTmpLrnRecMp;
			RcrdIndex[ATD2LrnValidRecNum] = ATD2LrnValidRecNum;
			RcrdSz[ATD2LrnValidRecNum] = ATD2LrnRecSize;
			KakiSz[ATD2LrnValidRecNum] = *((UInt8*)ATD2LrnTmpLrnRecMp + 2);
			YomiSz[ATD2LrnValidRecNum] = *((UInt8*)ATD2LrnTmpLrnRecMp + 1) - 0x80;
			MemHandleUnlock (ATD2LrnTmpLrnRecMh);
//			DmReleaseRecord (ATOKLrnEditTmpDBRef,ATD2LrnValidRecNum,false);
//			DmReleaseResource (ATD2LrnTmpLrnRecMh);

//---------------------
//			MoveTmpDbRecToSortedPosition(ATOKLrnEditTmpDBRef,ATD2LrnValidRecNum + 1);
//---------------------

			ATD2LrnValidRecNum++;
			ATD2LrnValidRecTotalSize += ((UInt16)ATD2LrnRecSize - 1);
		}

	}while (offset < ((LrnRecLstRecAddress - LrnRec1stRecAddress)& 0x0FFF));


Ret:
	if (ATD2LrnDbRecMhLocked == true)
		MemHandleUnlock (ATD2LrnDbRecMh);
	if (ATD2LrnDbOpened == true)
		DmCloseDatabase (ATD2LrnDbRef);
	sortRes();
//------------------------------------------------------------------------------
	FrmEraseForm (WaitfrmP);
	FrmSetActiveForm (pForm);
//------------------------------------------------------------------------------

	if (error == true)
	{
		FrmAlert (ErrorMemAlert);
		return false;
	}

	objIndex = FrmGetObjectIndex (pForm,MainValidNumLabel);
	FrmHideObject (pForm,objIndex);
	StrIToA((char*)FrmGetLabel (pForm,MainValidNumLabel),(Int32)ATD2LrnValidRecNum);
	FrmShowObject (pForm,objIndex);
	objIndex = FrmGetObjectIndex (pForm,MainInvalidNumLabel);
	FrmHideObject (pForm,objIndex);
	StrIToA((char*)FrmGetLabel (pForm,MainInvalidNumLabel),(Int32)ATD2LrnInvalidRecNum);
	FrmShowObject (pForm,objIndex);
	objIndex = FrmGetObjectIndex (pForm,MainValidRecSizeLabel);
	FrmHideObject (pForm,objIndex);
	StrIToA((char*)FrmGetLabel (pForm,MainValidRecSizeLabel),(Int32)(ATD2LrnValidRecTotalSize+ATD2LrnInvalidRecTotalSize));
	FrmShowObject (pForm,objIndex);

	if (ATD2LrnValidRecNum>9)
		ATD2LrnValidRecNum -= 9;
	else
		ATD2LrnValidRecNum = 0;
	
	SclSetScrollBar ((ScrollBarPtr)FrmGetObjectPtr (pForm,FrmGetObjectIndex (pForm,MainRecListScrollBar))
					,(Int16)0,(Int16)0,(Int16)ATD2LrnValidRecNum,(Int16)8);

	return true;
}

Err DrawList()
{
	UInt8 i;
	FormType* pForm = FrmGetFormPtr (MainForm);

	for (i=0;i<=8;i++)
	{
		CtlNewControl ((void**)&pForm,(UInt16)1051+i,checkboxCtl,"",10+0,13+15+i*11,130,11,(FontID)0,0,true);
//		CtlSetEnabled (CtlNewControl ((void**)&pForm,(UInt16)1051+i,checkboxCtl,"",10+0,13+15+i*11,130,11,(FontID)0,0,true), !ATOKIsActive);
		FrmNewLabel ((FormType**)&pForm,(UInt16)1031+i,"0123456789",10+15,13+15+i*11,(FontID)0);
		FrmNewLabel ((FormType**)&pForm,(UInt16)1041+i,"0123456789012345",10+63,13+15+i*11,(FontID)0);
	}
	CtlSetEnabled ((ControlType*)FrmGetObjectPtr (pForm, FrmGetObjectIndex (pForm,MainUnnamed1000PushButton)), false);
	return true;
}

Err FillRecList(Int8 ScrollDirection)
{
	Int16 ListingTopRecNum;
	FormType* pForm = FrmGetFormPtr (MainForm);
	UInt16 Label;

	UInt32 ATD2LrnRecNum;

	UInt8 i;
	UInt16 objIndex;

	UInt8 recSize;
	UInt8 yomiSize;
	UInt8 kakuteiSize;

	Char tmpStr[100];

	ScrollBarPtr bar = (ScrollBarPtr)FrmGetObjectPtr (pForm,FrmGetObjectIndex (pForm,MainRecListScrollBar));

	Int16 value;
	Int16 min;
	Int16 max;
	Int16 pageSize;

	SclGetScrollBar (bar,&value,&min,&max,&pageSize);
	ListingTopRecNum = value;
	
//	DmDatabaseSize (0, ATOKLrnEditTmpDBId,&ATD2LrnRecNum,NULL,NULL);
	ATD2LrnRecNum = DmNumResources (ATOKLrnEditTmpDBRef);

	if (ListingTopRecNum + ScrollDirection < 0)
	{
		ListingTopRecNum = 0;
		ScrollDirection = 0;
	}
	if (ListingTopRecNum + ScrollDirection + 9 >= ATD2LrnRecNum)
	{
		ListingTopRecNum = (Int16)ATD2LrnRecNum - 9;
		if (ListingTopRecNum < 0)
			ListingTopRecNum = 0;
		ScrollDirection = 0;
	}
	
	ListingTopRecNum += ScrollDirection;
	
	for (i = 0;i <= 8;i++)
	{
		ATD2LrnTmpLrnRecMh = DmGetResource ('temp', (DmResID)(i + ListingTopRecNum));
		if (ATD2LrnTmpLrnRecMh != NULL)
		{
			UInt16 index = RcrdIndex[(DmResID)(i + ListingTopRecNum)];
			ATD2LrnTmpLrnRecMp = (UInt8*)RcrdMp[index];
			
			objIndex = FrmGetObjectIndex (pForm,(UInt16)(1051 + i));
			CtlSetValue ((ControlType*)FrmGetObjectPtr (pForm,objIndex),(Int16)(*(UInt8*)ATD2LrnTmpLrnRecMp));

			recSize = RcrdSz[index];
			kakuteiSize = KakiSz[index];
			yomiSize = YomiSz[index];

			StrNCopy (tmpStr, (Char*)((UInt8*)ATD2LrnTmpLrnRecMp+1+2),(Int8)yomiSize);
			tmpStr[yomiSize] = 0;
			tmpStr[8] = 0x18;
			tmpStr[9] = 0x00;
			Label = (UInt16)(1031 + i);
			FrmCopyLabel (pForm,Label,tmpStr);

			StrNCopy (tmpStr, (Char*)((UInt8*)ATD2LrnTmpLrnRecMp+1+1+yomiSize+1),(Int8)kakuteiSize);
			tmpStr[kakuteiSize] = 0;
			tmpStr[14] = 0x18;
			tmpStr[15] = 0x00;
			Label = (UInt16)(1041 + i);
			FrmCopyLabel (pForm,Label,tmpStr);

			objIndex = FrmGetObjectIndex (pForm,(UInt16)(1051 + i));
			FrmShowObject (pForm,objIndex);

			objIndex = FrmGetObjectIndex (pForm,(UInt16)(1031 + i));
			FrmShowObject (pForm,objIndex);

			objIndex = FrmGetObjectIndex (pForm,(UInt16)(1041 + i));
			FrmShowObject (pForm,objIndex);
		}
		else
		{
			objIndex = FrmGetObjectIndex (pForm,(UInt16)(1051 + i));
			FrmHideObject (pForm,objIndex);
		
			objIndex = FrmGetObjectIndex (pForm,(UInt16)(1031 + i));
			FrmHideObject (pForm,objIndex);

			objIndex = FrmGetObjectIndex (pForm,(UInt16)(1041 + i));
			FrmHideObject (pForm,objIndex);
		}
	}

	value = ListingTopRecNum;
	SclSetScrollBar (bar,value,min,max,pageSize);

return true;
}

void ResetDeleteFlug()
{
	Int16 i;

	UInt16 ATD2LrnRecNum;

	Boolean Flug;

	ATD2LrnRecNum = DmNumResources (ATOKLrnEditTmpDBRef);

	for (i = 0;i < ATD2LrnRecNum;i++)
	{
		ATD2LrnTmpLrnRecMh = DmGetResource ('temp', (DmResID)i);
		if (ATD2LrnTmpLrnRecMh != NULL)
		{
			ATD2LrnTmpLrnRecMp = MemHandleLock (ATD2LrnTmpLrnRecMh);
			Flug = false;
			DmWrite (ATD2LrnTmpLrnRecMp
				, 0
				, &Flug
				, (UInt32)1);
			MemHandleUnlock (ATD2LrnTmpLrnRecMh);

			DmReleaseResource (ATD2LrnTmpLrnRecMh);
		}
	}
}

void GetDeleteFlug()
{
	Int16 ListingTopRecNum;
	FormType* pForm = FrmGetFormPtr (MainForm);

	UInt8 i;
	UInt16 objIndex;

	ScrollBarPtr bar = (ScrollBarPtr)FrmGetObjectPtr (pForm,FrmGetObjectIndex (pForm,MainRecListScrollBar));

	Int16 value;
	Int16 min;
	Int16 max;
	Int16 pageSize;

	Boolean Flug;
	
	SclGetScrollBar (bar,&value,&min,&max,&pageSize);
	ListingTopRecNum = value;

	for (i = 0;i <= 8;i++)
	{
		ATD2LrnTmpLrnRecMh = DmGetResource ('temp', (DmResID)(i + ListingTopRecNum));
		if (ATD2LrnTmpLrnRecMh != NULL)
		{
			UInt16 index = RcrdIndex[(DmResID)(i + ListingTopRecNum)];
			ATD2LrnTmpLrnRecMp = (UInt8*)RcrdMp[index];

			objIndex = FrmGetObjectIndex (pForm,1051 + (UInt16)i);

			if (CtlGetValue((ControlType*)FrmGetObjectPtr(pForm,objIndex)) == 1)
				Flug = true;
			else
				Flug = false;

			DmWrite (ATD2LrnTmpLrnRecMp
				, 0
				, &Flug
				, (UInt32)1);

			DmReleaseResource (ATD2LrnTmpLrnRecMh);
		}
	}
}

void UpdateATD2LrnRec()
{
	Int16 i;

	UInt32 ATD2LrnRecNum;

	LocalID ATD2LrnDbId;
	DmOpenRef ATD2LrnDbRef;
	MemHandle ATD2LrnDbRecMh;
	MemPtr ATD2LrnDbRecMp;

	UInt32 ATD2LrnTmpLrnRecSize = 0;
	UInt16 LrnRecTotalSize = 0;
	UInt16 tmp = 0x0000;
	
//------------------------------------------------------------------------------

	ATD2LrnDbId = DmFindDatabase (0, "ATD2Lrn");
	ATD2LrnDbRef = DmOpenDatabase (0, ATD2LrnDbId, dmModeReadWrite);
	ATD2LrnDbRecMh = DmQueryRecord (ATD2LrnDbRef,1);
	ATD2LrnDbRecMp = MemHandleLock (ATD2LrnDbRecMh);

	ATD2LrnRecNum = DmNumResources (ATOKLrnEditTmpDBRef);

	DmSet (ATD2LrnDbRecMp, 4, 4096, 0);

	for (i = (Int16)ATD2LrnRecNum - 1;i >= 0;i--)
	{
		ATD2LrnTmpLrnRecMp = RcrdMp [i];
		ATD2LrnTmpLrnRecSize = RcrdSz [i];
		if (*(Boolean*)ATD2LrnTmpLrnRecMp != true)
		{
			DmWrite (ATD2LrnDbRecMp,5 + LrnRecTotalSize,(UInt8*)ATD2LrnTmpLrnRecMp+1,ATD2LrnTmpLrnRecSize);
			LrnRecTotalSize += (UInt16)ATD2LrnTmpLrnRecSize;
		}
	}

	DmWrite (ATD2LrnDbRecMp,2,&LrnRecTotalSize,2);
	LrnRecTotalSize = 0;
	DmWrite (ATD2LrnDbRecMp,0,&LrnRecTotalSize,2);

	MemHandleUnlock (ATD2LrnDbRecMh);
	DmCloseDatabase (ATD2LrnDbRef);
}

Boolean CheckVersion()
{
	UInt32 romVersion;

	UInt32 MhSize;
	LocalID DbId;
	DmOpenRef DbRef;
	MemHandle RecMh;
	MemHandle ResMh;
	MemPtr ResMp;
	long version;

	FtrGet(sysFtrCreator, sysFtrNumROMVersion, &romVersion);
	if ((romVersion & 0x04000000) != 0x04000000)
	{
		goto RomVersionErr;
	}

	DbId = DmFindDatabase (0, "ATOKProp");
	if (DbId != 0)
	{
		DbRef = DmOpenDatabase (0,DbId,dmModeReadOnly);
		ResMh = DmGetResource ('tver',1000);
		MhSize = MemHandleSize (ResMh);
		ResMp = MemHandleLock (ResMh);
		version = *(long*)ResMp & (long)'2.0.';
		MemHandleUnlock (ResMh);
		DmReleaseResource (ResMh);
		DmCloseDatabase (DbRef);
		if (version!=(long)'2.0.')
			goto ATOKVersionErr;
	}
	else
	{
		goto ATOKVersionErr;
	}
	
	
	DbId = DmFindDatabase (0, "ATD2Lrn");
	if (DbId != 0)
	{
		DbRef = DmOpenDatabase (0,DbId,dmModeReadOnly);
		RecMh = DmQueryRecord (DbRef,1);
		MhSize = MemHandleSize (RecMh);
		DmCloseDatabase (DbRef);
		if(MhSize!=4100)
			goto ATOKVersionErr;
	}
	else
		goto ATOKVersionErr;

	return true;

RomVersionErr:
	FrmAlert (RomVerErrorAlert);
	goto ReturnFalse;
ATOKVersionErr:
	FrmAlert (ATOKVerErrorAlert);
ReturnFalse:
	return false;
}

void BackUp()
{
LocalID bkdbID;
DmOpenRef bkdbRef;
DmOpenRef atdbRef;
MemHandle bkrecMh;
MemHandle atrecMh;
MemPtr bkrecMp;
MemPtr atrecMp;
UInt16 at = 1;
UInt16 attributes;

	//Check BackupFile Existence
	if (DmFindDatabase (0, "ATOKLrnEditBackup") != 0)
	{
		FrmAlert (ErrExistAlert);// "łɃobNAbv݂܂ obNAbv폜Ă"
		return;//AlreadyExist
	}

	if (DmCreateDatabase (0, "ATOKLrnEditBackup", 'LrnE', 'back', false) != errNone)
	{
		FrmAlert (ErrCantCreateAlert);// "obNAbv쐬ł܂ł"
		return;//Can't create
	}
	
	bkdbID = DmFindDatabase (0, "ATOKLrnEditBackup");
	
	DmDatabaseInfo (0, bkdbID, NULL, &attributes, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	attributes = attributes | dmHdrAttrBackup;
	DmSetDatabaseInfo (0, bkdbID, NULL, &attributes, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	bkdbRef = DmOpenDatabase (0, bkdbID, dmModeWrite);
	bkrecMh = DmNewRecord (bkdbRef, &at, 4100);
	if ( bkrecMh == 0)
	{
		DmDeleteDatabase (0, bkdbID);
		FrmAlert (ErrCantCreateAlert);// "obNAbv쐬ł܂ł"
		return;//Can't create
	}
	atdbRef = DmOpenDatabase (0, DmFindDatabase (0, "ATD2Lrn"), dmModeReadOnly);
	atrecMh = DmQueryRecord (atdbRef, 1);
	atrecMp = MemHandleLock (atrecMh);

	if (bkrecMh != 0)
	{
		bkrecMp = MemHandleLock (bkrecMh);

		DmWrite (bkrecMp, 0, atrecMp, 4100);

		MemHandleUnlock (bkrecMh);
		DmReleaseRecord (bkdbRef,at,false);
	}
	MemHandleUnlock (atrecMh);
	DmReleaseRecord (atdbRef,at,false);
	DmCloseDatabase (bkdbRef);
	DmCloseDatabase (atdbRef);

	FrmAlert (BackupDoneAlert);// "obNAbv܂"
	return;//Error none
}

Boolean Restore()
{
DmOpenRef bkdbRef;
DmOpenRef atdbRef;
MemHandle bkrecMh;
MemHandle atrecMh;
MemPtr bkrecMp;
MemPtr atrecMp;

//UInt32 result;

LocalID dbID = DmFindDatabase (0, "ATOKLrnEditBackup");

	if ( dbID == 0)
	{
		FrmAlert (ErrCantFineAlert);// "obNAbv܂"
		return false;//NotExist
	}

	bkdbRef = DmOpenDatabase (0, dbID, dmModeReadOnly);
	atdbRef = DmOpenDatabase (0, DmFindDatabase (0, "ATD2Lrn"), dmModeWrite);
	bkrecMh = DmQueryRecord (bkdbRef, 0);
	atrecMh = DmQueryRecord (atdbRef, 1);
	bkrecMp = MemHandleLock (bkrecMh);
	atrecMp = MemHandleLock (atrecMh);
	DmWrite (atrecMp, 0, bkrecMp, 4100);
	MemHandleUnlock (bkrecMh);
	MemHandleUnlock (atrecMh);
	DmCloseDatabase (bkdbRef);
	DmCloseDatabase (atdbRef);
	
	return true;//Error none
}

void DeleteBackup()
{
LocalID dbID = DmFindDatabase (0, "ATOKLrnEditBackup");

	if ( dbID == 0)
	{
		FrmAlert (ErrCantFineAlert);// "obNAbv܂"
		return;//NotExist
	}

	if ( DmDeleteDatabase (0, dbID) != errNone)
	{
		FrmAlert (ErrCantDeleteAlert);// "obNAbv폜ł܂ł"
		return;
	}

	FrmAlert (DeleteDoneAlert);// "obNAbv폜܂"

	return;//Error none
}

UInt32 GetAddr(UInt32 ATD2LrnRecIndex1Addr, UInt16 RecLstAddr, UInt16 Offset)
{
	return ATD2LrnRecIndex1Addr + 4 + (UInt16)((RecLstAddr - Offset) & 0x0FFF);
}

void LaunchATOK ()
{
	UInt32 trapadd;

	SysUIAppSwitch (0, DmFindDatabase (0, "ATOKProp"),
//	SysUIAppSwitch (0, DmFindDatabase (0, "Address Book"),
		sysAppLaunchCmdNormalLaunch, NULL);

	trapadd = (UInt32)SysGetTrapAddress (sysTrapSysUIAppSwitch);
	FtrSet ('LrnE', SysUIAppSwitchTrapFtrNum, (UInt32)SysGetTrapAddress (sysTrapSysUIAppSwitch));
	SysSetTrapAddress (sysTrapSysUIAppSwitch, &SysUIAppSwitchTrapHack);

	UInt32 LnchCrtrId = PrefGetPreference (prefLauncherAppCreator);
	FtrSet ('LrnE', SysUIAppSwitchTrapLnchrCrtrId, LnchCrtrId);

	return;
}

void FrmRefresh()
{
	FrmUpdateForm (MainForm, frmRedrawUpdateCode);//--------------------------------
}

Boolean ChkATOKActive()
{
	if (ATOKActive == true)
	{
		if (FrmAlert (ErrActiveAlert) == ErrActiveATOK)// "ϊgpȂݒɂĂ"
		{
			LaunchATOK ();
		}
		return true;
	}
//
	return false;
}

Boolean ChkATOK()
{
UInt16 tsmlPref[50];
UInt16 tsmlPrefSize = 49;

	PrefGetAppPreferences('tsml', 0x01, &tsmlPref, &tsmlPrefSize, true);

	if ((tsmlPref[0] == 'Li') && (tsmlPref[1] == 'bA') && (tsmlPref[2] == 'TO') && (tsmlPref[3] == 'KP'))
	{
		ATOKActive = true;
		return true;
	}
//
	return false;
}

void sortRes()
{
	DmResID i;
	DmResID curResID;
	DmResID fndResID;
	UInt16 curResIndex;
	UInt16 fndResIndex;

	UInt16 resNum = DmNumResources (ATOKLrnEditTmpDBRef);
	if (resNum == 0)
		return;
	
	FntSetFont (stdFont);
	for (i=0; i<resNum-1; i++)
	{
		if(i == i/5*5)
		{
			WinEraseChars ("....", 4, 70, 5);
			WinDrawChars ("....", ((i/5)&3)+1, 70, 5);
		}
		curResID = i;
		fndResID = sort(i, resNum - 1);
		curResIndex = RcrdIndex[i];
		fndResIndex = RcrdIndex[fndResID];
//	error =	DmSetResourceInfo (dbRef, curResIndex, NULL, &fndResID);
	RcrdIndex[fndResID] = curResIndex;
//	error = DmSetResourceInfo (dbRef, fndResIndex, NULL, &curResID);
	RcrdIndex[curResID] = fndResIndex;
	}

	return;
}

DmResID sort(DmResID FstResID, DmResID LstResID)
{
	DmResID i;
	DmResID j = FstResID;

	UInt8 CmpSize;////

	UInt16 iResIndex;
	UInt16 jResIndex;

	Int16 cmpres;

	for (i = FstResID + 1; i < LstResID; i++)
	{
		iResIndex = RcrdIndex[i];
		jResIndex = RcrdIndex[j];

		if (YomiSz[iResIndex] < YomiSz[jResIndex])
			CmpSize = YomiSz[iResIndex];
		else
			CmpSize = YomiSz[jResIndex];

		cmpres = StrNCompareAscii ((Char*)RcrdMp[iResIndex] + 3, (Char*)RcrdMp[jResIndex]+ 3, CmpSize);
		if (cmpres < 0)
		{
			j = i;
		}
		if (cmpres == 0)
		{
			if (YomiSz[iResIndex] < YomiSz[jResIndex])
			{
				j = i;
			}
			if (YomiSz[iResIndex] == YomiSz[jResIndex])
			{
				if (KakiSz[iResIndex] < KakiSz[jResIndex])
					CmpSize = KakiSz[iResIndex];
				else
					CmpSize = KakiSz[jResIndex];

				cmpres = StrNCompareAscii ((Char*)RcrdMp[iResIndex] + 3 + YomiSz[iResIndex], (Char*)RcrdMp[jResIndex]+ 3 + YomiSz[jResIndex], CmpSize);
				if (cmpres < 0)
				{
					j = i;
				}
				if (cmpres == 0)
				{
					if (KakiSz[iResIndex] < KakiSz[jResIndex])
					{
						j = i;
					}
				}
			}
		}
	}

	return j;
}